Oracle Coherence for C++ API
Release 3.6.0.0
E15728-01

- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# ExtractorEventTransformer Class Reference

`#include <coherence/util/transformer/ExtractorEventTransformer.hpp>`

Inherits Object, PortableObject, and MapEventTransformer.

List of all members.

## Detailed Description

ExtractorEventTransformer is a special purpose MapEventTransformer implementation that transforms emitted events, extracting one or more properties from either the OldValue or the NewValue.

This transformation will generally result in the change of the values' data type.

Example: the following code will register a listener to receive events only if the value of the AccountBalance property changes. The transformed event's NewValue will be a List containing the LastTransactionTime and AccountBalance properties. The OldValue will always be null.

        Filter::View vFilter =
           ValueChangeEventFilter::create("getAccountBalance");
        ValueExtractor::View vExtractor =
           MultiExtractor::create(MultiExtractor::createExtractors(
               "getLastTransactionTime,getAccountBalance"));
        MapEventTransformer::Handle hTransformer =
           ExtractorEventTransformer::create(NULL, vExtractor);

        cache->addMapListener(listener,
           MapEventTransformerFilter::create(vFilter, hTransformer), false);

Author:
  djl 2008.06.17

## Public Types
typedef spec::Handle | Handle
| ExtractorEventTransformer Handle definition.
typedef spec::View | View
| ExtractorEventTransformer View definition.
typedef spec::Holder | Holder
| ExtractorEventTransformer Holder definition.
## Public Member Functions
virtual MapEvent::Handle | transform (MapEvent::Handle hEvent) const
  | Transform the specified MapEvent. The values contained by the returned MapEvent object will be the ones given (sent) to the corresponding listener. Parameters:
  | hEvent | the original MapEvent object
Returns: modified MapEvent object or NULL to discard the event
virtual void | readExternal (PofReader::Handle hIn)
virtual void | writeExternal (PofWriter::Handle hOut) const
virtual bool | equals (Object::View v) const
virtual size32_t | hashCode () const
| Return a hash code value for the Object. This method is supported for the benefit of hash-based containers. The general contract of `hashCode` is: Whenever it is invoked on the same Object more than once during an execution of an application, the `hashCode` method must consistently return the same value, provided no information used in `equals` comparisons on the object is modified. This value need not remain consistent from one execution of an application to another execution of the same application. If two Objects are equal according to the `equals` method, then calling the `hashCode` method on each of the two Objects must produce the same value. It is not required that if two Objects are unequal according to the `equals` method, then calling the `hashCode` method on each of the two objects must produce distinct results. However, the programmer should be aware that producing distinct results for unequal objects may improve the performance of hash-based containers. The default implementation is identity based. Returns: a hash code value for this Object
virtual void | toStream (std::ostream &out) const
| Output a human-readable description of this Object to the given stream. coherence::lang::operator<<(std::ostream, Object::View) is defined and will call into the toStream method, to output Objects. If a managed String object is desired, the COH_TO_STRING macro can be used to build up a String from streamable contents.
     Object::View vKey   = ...
     Object::View vValue = ...
     std::cout << vKey << " = " << vValue << std::endl;

     String::Handle hs = COH_TO_STRING(vKey << " = " << vValue);
  Parameters:
  | out | the stream used to output the description
virtual ValueExtractor::View | getOldValueExtractor () const
| Return a ValueExtractor used to transfrom the event's OldValue.
virtual ValueExtractor::View | getNewValueExtractor () const
| Return a ValueExtractor used to transfrom the event's NewValue.
## Protected Member Functions
| ExtractorEventTransformer ()
| Default constructor (necessary for the PortableObject interface).
| ExtractorEventTransformer (ValueExtractor::View vExtractor)
| Construct a ExtractorEventTransformer that transforms MapEvent values based on the specified extractor.
| ExtractorEventTransformer (ValueExtractor::View vExtractorOld, ValueExtractor::View vExtractorNew)
| Construct a ExtractorEventTransformer that transforms MapEvent values based on the specified extractors.

## Constructor & Destructor Documentation

ExtractorEventTransformer | ( | ValueExtractor::View | vExtractor | ) | `[protected]`

Construct a ExtractorEventTransformer that transforms MapEvent values based on the specified extractor.

Note: The specified extractor will be applied to both old and new values.

Parameters:

  | vExtractor | ValueExtractor to extract MapEvent values

ExtractorEventTransformer | ( | ValueExtractor::View | vExtractorOld,
|  | ValueExtractor::View | vExtractorNew |
| ) |  |  | `[protected]`

Construct a ExtractorEventTransformer that transforms MapEvent values based on the specified extractors.

Passing null indicates that the corresponding values should be skipped completely.

Parameters:

  | vExtractorOld | extractor to extract the OldValue property(s)
  | vExtractorNew | extractor to extract the NewValue property(s)

## Member Function Documentation

virtual ValueExtractor::View getOldValueExtractor | ( |  | ) | const `[virtual]`

Return a ValueExtractor used to transfrom the event's OldValue.

Returns:
  an extractor from the OldValue

virtual ValueExtractor::View getNewValueExtractor | ( |  | ) | const `[virtual]`

Return a ValueExtractor used to transfrom the event's NewValue.

Returns:
  an extractor from the NewValue

The documentation for this class was generated from the following file:

- coherence/util/transformer/ExtractorEventTransformer.hpp

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.